<template>
	<v-card>
		<v-dialog :value="submitHasError" max-width="50em" persistent>
			<v-card>
				<v-toolbar color="grey lighten-2" flat>
					<v-toolbar-title>Error</v-toolbar-title>
				</v-toolbar>
				<v-divider />
				<v-card-text>
					<div class="d-flex justify-center align-center mt-4 mx-2">
						<v-icon color="error">mdi-alert-circle</v-icon>
						<v-divider vertical class="mx-2"></v-divider>
						<p class="mt-0 mb-0">
							An error occurred while attempting to submit the sampling collection. Please try again.
						</p>
					</div>
				</v-card-text>
				<v-divider />
				<v-card-actions class="d-flex flex-wrap justify-end">
					<v-btn text rounded @click="acknowledgeSubmitError()" :disabled="submitIsLoading">Ok</v-btn>
				</v-card-actions>
			</v-card>
		</v-dialog>
		<v-toolbar color="grey lighten-2" flat>
			<v-toolbar-title>Submit Sampling Collection</v-toolbar-title>
		</v-toolbar>
		<v-divider />
		<v-card-text class="py-4">
			<span class="font-weight-bold">Field</span>: {{ field.name }}
			<br />
			<v-icon small class="mr-1"> mdi-triangle </v-icon>
			{{ progress }} locations collected
			<div class="d-flex justify-center align-center mt-4 mx-2">
				<template v-if="samplings.length !== 0">
					<v-icon color="warning">mdi-exclamation-thick</v-icon>
					<v-divider vertical class="mx-2"></v-divider>
					<p class="mt-0 mb-0">
						You will no longer be able to edit this sampling collection once you submit. Your in progress collection is
						automatically saved to your device. Are you sure you want to submit?
					</p>
				</template>
				<template v-else>
					<v-icon color="error">mdi-alert-octagon</v-icon>
					<v-divider vertical class="mx-2"></v-divider>
					<p class="mt-0 mb-0">You cannot submit an empty sampling collection.</p>
				</template>
			</div>
		</v-card-text>
		<v-divider />
		<v-card-actions class="d-flex flex-wrap justify-end">
			<v-btn class="mr-2" text rounded @click="$emit('closeDialog')" :disabled="submitIsLoading">Cancel</v-btn>
			<v-btn v-if="samplings.length !== 0" color="primary" text rounded @click="handleSubmit" :loading="submitIsLoading"
				>Confirm</v-btn
			>
		</v-card-actions>
	</v-card>
</template>

<script lang="ts">
import { defineComponent, computed } from '@vue/composition-api';
import { FeatureCollection, Feature } from 'geojson';
import { Field, SamplingCollection, Sampling, Sample } from '@/store/types';
import { prepareSamplingCollectionForSubmission } from './helpers';

export default defineComponent({
	props: {
		locations: {
			type: Object as () => FeatureCollection,
			required: true,
		},
		field: {
			type: Object as () => Field,
			required: true,
		},
		samplingCollection: {
			type: Object as () => SamplingCollection,
			required: true,
		},
		samplings: {
			type: Array as () => Sampling[],
			required: true,
		},
		samples: {
			type: Array as () => Sample[],
			required: true,
		},
	},
	setup(props, { root }) {
		const progress = computed(() => {
			if (props.locations) {
				const completed = props.locations.features.filter(
					(l: Feature) => l.properties?.markerType !== 'LOCATION_INCOMPLETE'
				).length;
				const total = props.locations.features.length;
				return `${completed} / ${total}`;
			}
		});

		const submitIsLoading = computed(() => root.$store.getters['resources/getSubmitIsLoading']);
		const submitHasError = computed(() => root.$store.getters['resources/getSubmitHasError']);

		const handleSubmit = () => {
			const submittableSamplingCollection = prepareSamplingCollectionForSubmission({
				samplingCollection: props.samplingCollection,
				samplings: props.samplings,
				samples: props.samples,
			});

			root.$store.dispatch('resources/submitSamplingCollection', {
				populatedSamplingCollection: submittableSamplingCollection,
				groupId: props.field.meta.groupId,
			});
		};

		const acknowledgeSubmitError = () => root.$store.dispatch('resources/acknowledgeSubmitSamplingCollectionError');

		return {
			progress,
			submitIsLoading,
			submitHasError,
			handleSubmit,
			acknowledgeSubmitError,
		};
	},
});
</script>

<style></style>
